package org.eclipse.corona.mylar;

import org.eclipse.core.runtime.Plugin;
import org.osgi.framework.BundleContext;

public class Activator extends Plugin
{
	private BundleContext m_BundleContext = null;
	private Mylar m_Mylar = null;
	private ContextListeners m_ContextListeners = null;
	
	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception
	{
		m_BundleContext = context;
		m_Mylar = new Mylar(context);
		m_ContextListeners = new ContextListeners();
	}

	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception
	{
		if (m_Mylar != null)
		{
			m_Mylar.close();
			m_Mylar = null;
		}
		
		if (m_ContextListeners != null)
		{
			m_ContextListeners.remove();
			m_ContextListeners = null;
		}
		
		m_BundleContext = null;
	}
}
