package org.eclipse.corona.mylar;

public interface IMylar
{
	/**
	 * 	Add a SELECTION event to the current Mylar context
	 * 
	 * @param	resourceName	Name of the resource being selected.
	 * @param	resourceKind	Kind of resource beinbg selected.
	 * @param	originId		Id of component selecting resource.
	 */
	public boolean addSelectionEvent(String resourceName, String resourceKind, String originId);
	
	/**
	 * 	Add a MANIPULATION event to the current Mylar context
	 * 
	 * @param	resourceName	Name of the resource being manipluated.
	 * @param	resourceKind	Kind of resource being manipluated.
	 * @param	originId		Id of component manipluating resource.
	 */
	public boolean addManipluationEvent(String resourceName, String resourceKind, String originId);
	
	/**
	 * 	Add a PROPAGATION event to the current Mylar context
	 * 
	 * @param	resourceName	Name of the resource being propgated.
	 * @param	resourceKind	Kind of resource being propagated.
	 * @param	originId		Id of component propgating the resource.
	 */
	public boolean addPropagationEvent(String resourceName, String resourceKind, String originId);
	
	/**
	 * 	Add a COMMAND event to the current Mylar activity
	 * 
	 * @param	resourceName	Name of the resource being propgated.
	 * @param	resourceKind	Kind of resource being propagated.
	 * @param	originId		Id of component propgating the resource.
	 * @param	command			The activity command.
	 */
	public boolean addActivityCommmand(String resourceName, String resourceKind, String originId, String command);
	
	/**
	 * Retrieve the name of the currently active Mylar element.
	 * 
	 * @return	The name of the active Mylar element. <code>null</code>
	 * 			is return if no active Mylar element.
	 */
	public String getCurrentElement();
	
	/**
	 * Upload the Mylar monitor history file to the Corona server.
	 */
	public void UpLoadHistory();
}
