package org.eclipse.corona.mylar;

import java.util.List;
import java.util.Collections;

import org.eclipse.mylar.context.core.AbstractContextStructureBridge;
import org.eclipse.mylar.context.core.AbstractRelationProvider;
import org.eclipse.mylar.context.core.IDegreeOfSeparation;

import org.eclipse.corona.model.container.ContextContainer;
import org.eclipse.corona.container.repository.IRepository;

public class StructuredBridge extends AbstractContextStructureBridge
{
	public final static String CONTENT_TYPE = "coronacontext";
	
	public StructuredBridge()
	{
		int jnwx = 0;
	}
	
	public boolean canBeLandmark(String handle)
	{
		return false;
	}

	public String getHandleIdentifier(Object object)
	{
		return "CoronaContext";
	}

	public boolean canFilter(Object element)
	{
		return true;
	}
	
	public boolean acceptsObject(Object object)
	{
		if ((object instanceof ContextContainer) || (object instanceof IRepository))
		{
			return true;
		}
		return false;
	}
	
	public List<AbstractRelationProvider> getRelationshipProviders()
	{
		return Collections.emptyList();
	}

	public String getName(Object object)
	{
		if (object instanceof ContextContainer)
		{
			return ((ContextContainer)object).getContainerUri();
//			return ((ContextContainer)object).getName();
		}
		else if  (object instanceof IRepository)
		{
			return ((IRepository)object).getName();
		}

		return "" + object;
	}
	
	public String getContentType()
	{
		return CONTENT_TYPE;
	}

	public String getContentType(String elementHandle)
	{
		return getContentType();
	}

	public String getParentHandle(String handle)
	{
		return null;
	}
	
	public String getHandleForOffsetInObject(Object resource, int offset)
	{
		return null;
	}
	
	public List<String> getChildHandles(String handle)
	{
		Object object = getObjectForHandle(handle);
		if (object instanceof ContextContainer)
		{
			ContextContainer contextContainer = (ContextContainer)object;
			List<String> childHandles = contextContainer.listRepositoryDescriptorNames();
		}
		return null;
	}
	
	public Object getObjectForHandle(String handle)
	{
		return null;
	}
	
	public List<IDegreeOfSeparation> getDegreesOfSeparation()
	{
		return Collections.emptyList();
	}

	public boolean isDocument(String handle)
	{
		return false;
	}

}
